#pragma once

#include <cxxabi.h>

#include "helper.h"

namespace cpprtti
{

    namespace __impl
    {

        struct tag_type_id { };
        struct tag_storage_id { };

        template<typename...>
        inline type_id create_id()
        {
            static type_id value { };
            return ++value;
        }

        template<typename X>
        inline std::string create_type_name()
        {
            int status;
            auto name = abi::__cxa_demangle(typeid(X).name(), nullptr, nullptr, &status);
            return std::string(name ? name : typeid(X).name());
        }

    }

    template<typename X>
    storage_id get_storage_id()
    {
        using namespace __impl;
        static const auto value = create_id<tag_storage_id>();
        return value;
    }

    template<typename X>
    type_id get_type_id()
    {
        using namespace __impl;
        static const auto value = create_id<tag_type_id>();
        return value;
    }

    template<typename X>
    const std::string& get_type_name()
    {
        static const auto value = __impl::create_type_name<X>();
        return value;
    }

}
