#pragma once

#include "default_type.h"

#include "../types/class_type_tpl.h"
#include "../types/fundamental_type_tpl.h"

namespace cpprtti
{

    template<typename T>
    struct default_type_trait<
        T,
        std::enable_if_t<std::is_fundamental_v<T>>>
    {
        using type = fundamental_type_tpl<T>;
    };

    template<typename T>
    struct default_type_trait<
        T,
        std::enable_if_t<std::is_class_v<T>>>
    {
        using type = class_type_tpl<T>;
    };

}
