#pragma once

#include <cppmp/misc/generic_predicate.h>

#include "member.h"
#include "../../misc/variant.h"

namespace cpprtti
{

    namespace __impl
    {

        template<typename X, typename = void>
        struct member_method_builder;

    }

    struct member_method
        : public member
    {
    public:
        /**
         * @brief Constructor.
         */
        inline member_method(
            cpprtti::type&      p_owner,
            const std::string&  p_name);

        /**
         * @brief Invoke the member method.
         */
        template<typename T_object, typename... T_args>
        inline variant invoke(T_object&& obj, T_args&&... args) const;

    protected:
        /**
         * @brief Invoke the member method.
         */
        virtual variant invoke_impl(const variant& obj, const std::vector<variant>& args) const = 0;
    };

    constexpr decltype(auto) make_member_method = cppmp::generic_predicate<__impl::member_method_builder> { };

}
