#pragma once

#include "type.h"

namespace cpprtti
{

    template<typename T_base>
    struct type_decorator
        : public T_base
    {
    public:
        using base_type = T_base;
        using converter = typename type::converter;

    public:
        using base_type::base_type;

        /**
         * @brief Set the converter that can convert this type to the passed type.
         */
        template<typename T_to>
        inline auto& convert_to(const converter& p_converter);

        /**
         * @brief Set the converter that can convert the passed type to this type.
         */
        template<typename T_from>
        inline auto& convert_from(const converter& p_converter);
    };

}
