#pragma once

#include <cppmp/core/modifier.h>

#include "type_decorator.h"
#include "../misc/helper.h"

namespace cpprtti
{

    /* type_decorator */

    template<typename T_base>
    template<typename T_to>
    auto& type_decorator<T_base>
        ::convert_to(const converter& p_converter)
    {
        using to_type = cppmp::decay_t<T_to>;

        auto id = get_type_id<to_type>();
        this->_converters[id] = p_converter;

        return *this;
    }

    template<typename T_base>
    template<typename T_from>
    auto& type_decorator<T_base>
        ::convert_from(const converter& p_converter)
    {
        using from_type = T_from;

        auto& type = this->_registry.template get<from_type>();
        type._converters[this->_id] = p_converter;

        return *this;
    }

}
